<?php

//-----------------------------------------------
// informations de connexion  la base de donnes
// database connection parameters
//-----------------------------------------------

$serveur='localhost';  // nom du serveur (ex: sql.free.fr ou localhost) | server name
$user='root';          // nom de l'utilisateur de la base de donnes | database user name
$password='';          // mot de passe de l'utilisateur de la base de donnes | password
$base='lesnews';          // nom de la base de donnes | database name
$table='lesnews';      // nom de la table contenant les news | table name

//---------------------------------------
// changez ces nombres selon votre besoin
// change these numbers to fit your needs
//---------------------------------------

$nnp = 3;              // nombre de news  afficher par page | displays x news per page

$jours = 7;            // si des news datent de moins de 7 jours une image "new"
                       // s'affiche devant le titre | displays "new" image during x days

//---------------------------------------
// changer les couleurs
// changing the colors
//---------------------------------------

$titlecolor      = '#FFFFFF';
$titlebgcolor    = '#6699CC';
$datecolor       = '#6699CC';
$datebgcolor     = '#FFFFFF';
$datebordercolor = '#6699CC';
$textcolor       = '#000000';
$textbgcolor     = '#FFFFFF';

//---------------------------------------------
// emplacement des images url, mail et new
// path to url, mail, new and navigation images
//---------------------------------------------

$urlimage  = 'images/url.gif';
$mailimage = 'images/mail.gif';
$newimage  = 'images/new.gif';
$navimageleft  = 'images/flecheg.gif';
$navimageright  = 'images/fleched.gif';

//--------------------------------------------------------------------------------
// End of configuration
//--------------------------------------------------------------------------------
//    Functions
//--------------------------------------------------------------------------------

/* replace links with images */
function replink($lien)
{ global $urlimage,$mailimage;
  $imggo=("<img src=".$urlimage." border=\"0\" alt=\"Go !\" align=\"absmiddle\">");
  $imgm=("<img src=".$mailimage." border=\"0\" alt=\"E-Mail !\" align=\"absmiddle\">");

// enlevez les commentaires aux 2 lignes ci-dessous pour ne pas afficher d'images
// delete the 2 comments if you do not want images
//        $imgm = ("\\1");
//        $imggo = ("\\1://\\2");

  $lien = eregi_replace(
    "l(http|https|ftp)://([[:alnum:]/\n+-=%&:_.~?]+[#[:alnum:]+]*)",
    "<a href=\"\\1://\\2\">$imggo</a>",
    $lien);

  $lien = eregi_replace(
    "lb(http|https|ftp)://([[:alnum:]/\n+-=%&:_.~?]+[#[:alnum:]+]*)",
    "<a href=\"\\1://\\2\" target=\"_blank\">$imggo</a>",
    $lien);

  $lien = eregi_replace(
    "(([a-z0-9_]|\\-|\\.)+@([^[:space:]]*)([[:alnum:]-])\.([^[:space:]]*)([[:alnum:]-]))",
    "<a href=\"mailto:\\1\">$imgm</a>",
    $lien);

  return $lien ;
}
/* server error */
function erreurServeurMySQL() {
  return "<CENTER><font face=verdana>&nbsp;&nbsp;".translate("Sorry ! MySQL server is down").".&nbsp;&nbsp;</font><CENTER>\n";
}
/* loading language file */
function get_translations($lngfile) {

  if (file_exists($lngfile)) {
    $lines = file($lngfile);
    while (list(,$line) = each($lines)) {
      list($key,$val)= explode("=",$line);
          $phrases[$key] = $val;
    }
    return $phrases;
  } else {
    return false;
  }
}
/* translate a string */
function translate($str,$vals="") {

  global $phrases;

  if ($phrases) {
    $p_str = $phrases[$str];
        if ($p_str == "") {
          $p_str = $str;
        }
  } else {
    $p_str = $str;
  }

  if (gettype($vals)=="array") {
    $p_str = sprintf($p_str,$vals[0],$vals[1],$vals[2],$vals[3],$vals[4],$vals[5],$vals[6]);
  }

  return (trim($p_str));
}
?>